<template>
  <div class="ver-bar-chart">

    <div class="y-axis-label">
      <span>{{ chartLabels.yAxisLabel }}</span>
    </div>

    <div class="ver-bar-chart__scale-area">
      <div class="ver-bar-chart__scale-area__scale-step" v-for="step in scaleAreaSteps" :key="step">{{ step }}</div>
    </div>

    <div class="ver-bar-chart__scroll-area-wrapper">
      <q-scroll-area visible class="ver-bar-chart__scroll-area">
        <div class="ver-bar-chart__content-columns-row">
          <div v-for="(value, key, index) in sortedData" :key="index" class="ver-bar-chart__content-column">
            <div class="ver-bar-chart__content-column__header-with-value">{{ value }} %</div>
            <div class="ver-bar-chart__content-column__grafic-part">
              <div class="ver-bar-chart__content-column__grafic-part__bar">
                <div
                  class="ver-bar-chart__content-column__grafic-part__bar__colored-bar"
                  :style="`height: ${value*scalingFactor}%`"
                >
                  <q-tooltip>
                    {{ key }} <br> {{ value }} %
                  </q-tooltip>
                </div>
              </div>
            </div>
            <div class="ver-bar-chart__content-column__footer-with-date">{{ normalizeDateString(key) }} <br> {{ key.split(".")[0] }}</div>
          </div>
        </div>
      </q-scroll-area>
    </div>
  </div>
  <div class="x-axis-label ">
    <span>
      {{ chartLabels.xAxisLabel }}
    </span>
  </div>
</template>

<script setup>
import { computed, toRaw } from 'vue';
import getChartLabels from 'src/composables/get_chart_labels';
import getNormalizedName from 'src/composables/get_normalized_name';

const props = defineProps({
  data:      { type: Object, required: true },
  indicator: { type: String, required: true },
});

const data = computed(() => {
  return Object.fromEntries(toRaw(props.data).map(item => [item.yearmonth, +item.porcentaje]));
});

const maxValue = Math.max(...Object.values(data.value));
let scalingFactor;
let scaleAreaSteps;

if (maxValue > 10) {
  scalingFactor=1;
  scaleAreaSteps = ['0 %', '10 %', '20 %', '30 %', '40 %', '50 %', '60 %', '70 %', '80 %', '90 %', '100 %'].reverse();
} else if (maxValue <= 10 && maxValue > 1) {
  scalingFactor=10;
  scaleAreaSteps = ['0 %', '1 %', '2 %', '3 %', '4 %', '5 %', '6 %', '7 %', '8 %', '9 %', '10 %'].reverse();
} else if (maxValue <= 1) {
  scalingFactor=100;
  scaleAreaSteps = ['0 %', '0.1 %', '0.2 %', '0.3 %', '0.4 %', '0.5 %', '0.6 %', '0.7 %', '0.8 %', '0.9 %', '1 %'].reverse();
}

const sortData = (data) => {
  const sortedKeys = Object.keys(data).sort();
  const sortedValues = sortedKeys.map(key => data[key]);
  return Object.fromEntries(sortedKeys.map((key, index) => [key, sortedValues[index]]));
};

let sortedData = computed(() => sortData(data.value));

const chartLabels = getChartLabels(props.indicator);

const normalizeDateString = (dateString) => {
  const month = parseInt(dateString.split(".")[1]) - 1;
  return getNormalizedName(month, 'month_short_name');
};

</script>

<style lang="scss">
@use './vertical-bar-chart-component-stylesheet.scss';
</style>